<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>tools/behaviourtree.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">tools/behaviourtree.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2004-2006 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_BEHAVIOUR_TREE__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_BEHAVIOUR_TREE__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;behaviourlayer/behave.h&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;tools/decorators.h&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;tools/parameters.h&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;tools/rewards.h&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;tools/triggers.h&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// Behaviour tree nodes</span>
<a name="l00031"></a>00031 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00032"></a>00032 
<a name="l00060"></a><a class="code" href="structiBTNode.html">00060</a> <span class="keyword">struct </span><a class="code" href="structiBTNode.html" title="This is a node of a behaviour tree.">iBTNode</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   SCF_INTERFACE (<a class="code" href="structiBTNode.html" title="This is a node of a behaviour tree.">iBTNode</a>, 0, 0, 1);
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiBTNode.html#a1079ef55b11c237982055580ae72f660" title="Execute this node.">Execute</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">celParams</a>&amp; params) = 0;
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiBTNode.html#ab1b594974911606569ef20311c5ff85b" title="Add a child node to this node.">AddChild</a> (<a class="code" href="structiBTNode.html" title="This is a node of a behaviour tree.">iBTNode</a>* child) = 0;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 };
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00078"></a>00078 <span class="comment">// Specific behaviour tree node implementations.</span>
<a name="l00079"></a>00079 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00080"></a>00080 
<a name="l00085"></a><a class="code" href="structiBTAction.html">00085</a> <span class="keyword">struct </span><a class="code" href="structiBTAction.html" title="This interface is implemented by the leaf action iBTNode that launches a list of CEL rewards...">iBTAction</a>: <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087   SCF_INTERFACE (<a class="code" href="structiBTAction.html" title="This interface is implemented by the leaf action iBTNode that launches a list of CEL rewards...">iBTAction</a>, 0, 0, 1);
<a name="l00088"></a>00088 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiBTAction.html#ad9c29894fe46df384a7304f036c888d7" title="Add a reward to be launched when this action node is executed.">AddReward</a> (<a class="code" href="structiReward.html" title="This is a reward.">iReward</a>* reward) = 0;
<a name="l00093"></a>00093 };
<a name="l00094"></a>00094 
<a name="l00099"></a><a class="code" href="structiParameterCheckCondition.html">00099</a> <span class="keyword">struct </span><a class="code" href="structiParameterCheckCondition.html" title="This interface is implemented by the leaf iBTNode that checks whether or not a parameter is equal to ...">iParameterCheckCondition</a>: <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   SCF_INTERFACE (<a class="code" href="structiParameterCheckCondition.html" title="This interface is implemented by the leaf iBTNode that checks whether or not a parameter is equal to ...">iParameterCheckCondition</a>, 0, 0, 1);
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiParameterCheckCondition.html#a110d730f35947b72506f5886473d41c9" title="Set the parameter to be checked by this node.">SetParameter</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* parameter) = 0;
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiParameterCheckCondition.html#a8a31904a1a49540f43b9b80043762bcb" title="Set the value that will be checked against the parameter.">SetValue</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* value) = 0;
<a name="l00112"></a>00112 };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00120"></a><a class="code" href="structiTriggerFiredCondition.html">00120</a> <span class="keyword">struct </span><a class="code" href="structiTriggerFiredCondition.html" title="This interface is implemented by the leaf iBTNode that monitors a CEL trigger.">iTriggerFiredCondition</a>: <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122   SCF_INTERFACE (<a class="code" href="structiTriggerFiredCondition.html" title="This interface is implemented by the leaf iBTNode that monitors a CEL trigger.">iTriggerFiredCondition</a>, 0, 0, 1);
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTriggerFiredCondition.html#aeecf8515be3635f423e6282ba2e31f54" title="Set the trigger to be monitored by this node.">SetTrigger</a> (<a class="code" href="structiTrigger.html" title="This is a trigger.">iTrigger</a>* trigger) = 0;
<a name="l00128"></a>00128 
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiTriggerFiredCondition.html#a6640d77635fbc3d34dd5c64c923d5d57" title="Set whether or not the execution of the condition will return true once or forever once the trigger h...">SetFireOnce</a> (<span class="keywordtype">bool</span> once) = 0;
<a name="l00137"></a>00137 };
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00140"></a>00140 
<a name="l00144"></a>00144 <span class="preprocessor">#define CEL_DECLARE_BTNODE(name)                                        \</span>
<a name="l00145"></a>00145 <span class="preprocessor">class cel##name : public scfImplementation2&lt;                            \</span>
<a name="l00146"></a>00146 <span class="preprocessor">                cel##name ,iBTNode, iComponent&gt;                         \</span>
<a name="l00147"></a>00147 <span class="preprocessor">{                                                                       \</span>
<a name="l00148"></a>00148 <span class="preprocessor">private:                                                                \</span>
<a name="l00149"></a>00149 <span class="preprocessor">  iObjectRegistry* object_reg;                                          \</span>
<a name="l00150"></a>00150 <span class="preprocessor">  csRefArray&lt;iBTNode&gt; children;                                         \</span>
<a name="l00151"></a>00151 <span class="preprocessor">public:                                                                 \</span>
<a name="l00152"></a>00152 <span class="preprocessor">  cel##name (iBase* parent);                                            \</span>
<a name="l00153"></a>00153 <span class="preprocessor">  virtual ~cel##name () { }                                             \</span>
<a name="l00154"></a>00154 <span class="preprocessor">  virtual bool Initialize (iObjectRegistry*);                           \</span>
<a name="l00155"></a>00155 <span class="preprocessor">  virtual bool Execute (const celParams&amp; params);                       \</span>
<a name="l00156"></a>00156 <span class="preprocessor">  virtual bool AddChild (iBTNode* child);                               \</span>
<a name="l00157"></a>00157 <span class="preprocessor">};</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span>
<a name="l00162"></a>00162 <span class="preprocessor">#define CEL_IMPLEMENT_BTNODE(name)                                      \</span>
<a name="l00163"></a>00163 <span class="preprocessor">cel##name::cel##name (iBase* parent)                                    \</span>
<a name="l00164"></a>00164 <span class="preprocessor"> : scfImplementationType (this, parent), object_reg(0)                  \</span>
<a name="l00165"></a>00165 <span class="preprocessor">{                                                                       \</span>
<a name="l00166"></a>00166 <span class="preprocessor">}                                                                       \</span>
<a name="l00167"></a>00167 <span class="preprocessor">bool cel##name::Initialize (                                            \</span>
<a name="l00168"></a>00168 <span class="preprocessor">        iObjectRegistry* object_reg)                                    \</span>
<a name="l00169"></a>00169 <span class="preprocessor">{                                                                       \</span>
<a name="l00170"></a>00170 <span class="preprocessor">  cel##name::object_reg = object_reg;                                   \</span>
<a name="l00171"></a>00171 <span class="preprocessor">  return true;                                                          \</span>
<a name="l00172"></a>00172 <span class="preprocessor">}                                                                       </span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>
<a name="l00174"></a>00174 <span class="preprocessor">#endif // __CEL_BEHAVIOUR_TREE__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
